#!/usr/bin/perl
# $Id: form_cfg_aliases.cgi,v 1.1.0.1 1998/11/02 09:36:23 jens Stable jens $
# $Date: 1998/11/02 09:36:23 $
#
# File: form_cfg_aliases.cgi
# Desc: interprete the aliases form
#       and create the config-file etc/aliases.cfg
#
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# (c) Copyright 1998 J. Hellmerichs-Friedrich
#
# $Log: form_cfg_aliases.cgi,v $
# Revision 1.1.0.1  1998/11/02 09:36:23  jens
# .
#
# Revision 1.1  1998/11/02 09:35:44  jens
# Initial revision
#
# Revision 1.1  1998/11/02 09:33:23  jens
# Initial revision
#
# Revision 1.0.9.1  1998/06/01 19:34:38  jens
# initial ci -r 1.0.9
#
# Revision 1.0  1998/06/01 19:32:22  jens
# initial ci -r 1.0
#
#

@Names = ( "CFG_ALIASES" );

%Wert = ( 'CFG_ALIASES', '' );

$fwdir=`pwd`;
$fwdir =~ s/\/cgi-bin//;
chomp ($fwdir);

&read_form;
&create_file;
#&print_form;
&print_file;

sub read_form {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/, $buffer);

    foreach $pair (@pairs)
    {
        local($name, $value) = split(/=/, $pair);
 
        $name =~ tr/+/ /;
        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $name =~ s/('|,)//g;

        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        $value =~ s/\r//g;
        $value =~ s/<!--(.|\n)*-->//g;
        
        if (defined ($Wert{$name})) {
            $Wert{$name} = $value;
        }
    }
}

sub print_form
{
    print "Content-type: text/plain\n\n";
    foreach $name (@Names)
    {
        print "$name=\"$Wert{$name}\"\n";
    }
}

sub create_file
{
    $file = "$fwdir/etc/aliases.cfg";
    open (FH, ">$file");
    print FH "$Wert{'CFG_ALIASES'}";
    close (FH);
}

sub print_file
{
    $file = "$fwdir/etc/aliases.cfg";
    open (FH, "$file");
    print "Content-type: text/plain\n\n";
    while (<FH>) {
        print ;
    }
    close (FH);
}
