#!/bin/sh
#
# $Date: 1998/11/02 09:36:23 $
# $Id: fill_aliases_cfg.cgi,v 1.1.0.1 1998/11/02 09:36:23 jens Stable jens $
#
# File: fill_aliases_cfg.cgi
# Desc: fill the Aliases form
#       with the current definitions
#
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2, or (at your option)
#   any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
# (c) Copyright 1998 J. Hellmerichs-Friedrich
#
# $Log: fill_aliases_cfg.cgi,v $
# Revision 1.1.0.1  1998/11/02 09:36:23  jens
# .
#
# Revision 1.1  1998/11/02 09:35:44  jens
# Initial revision
#
# Revision 1.1  1998/11/02 09:33:23  jens
# Initial revision
#
# Revision 1.0.9.1  1998/06/01 19:34:33  jens
# initial ci -r 1.0.9
#
# Revision 1.0  1998/06/01 19:32:20  jens
# initial ci -r 1.0
#
#

# where is the firewall-package located ?
[ -z "$FWDIR" ] && FWDIR=`echo $0 | sed -e 's/[\/]cgi-bin[\/][A-Za-z0-9_\.-]*$//'`

CFG_NAME=aliases
CFG_FILE=$FWDIR/etc/$CFG_NAME.cfg

if [ ! -r $CFG_FILE ]; then
    echo "Error: Missing $CFG_FILE"
    exit 0
fi

echo Content-type: text/html
echo ""

cat $FWDIR/etc/sheets/${CFG_NAME}_cfg_head.htm
cat $CFG_FILE
cat $FWDIR/etc/sheets/${CFG_NAME}_cfg_end.htm
